;
; This is the code present on the FIRST page.  It copies the monitor
; from the flash to RAM.  The monitor has to be in RAM to read from
; different flash pages.
;
; All code is available at http://www.stockly.com
;     or by e-mailing grant@stockly.com
;
	cpu	6800
	relaxed on
	
SOURCE	EQU	$8400
END		EQU	$93F0
DESTINATION	EQU	$7000

	ORG	$7FFC

READ	RMB	2	;Counter for SOURCE location
WRITE	RMB	2	;Counter for DESTINATION location

	ORG	$8000
	
	FCB	[16]$01	;Fill first 16 bytes with NOPs for page switches
	
	JMP	START
	

START	LDX	#SOURCE
	STX	READ
	LDX	#DESTINATION
	STX	WRITE
	
LOOP	LDX	READ
	CPX	#END
	BEQ	BOOT
	LDA	B, 0, X
	INX
	STX	READ
	
	LDX	WRITE
	STA	B, 0, X
	INX
	STX	WRITE
	
	JMP	LOOP

BOOT	JMP	$7000

	FCB	[(*+1023)&$fffffc00-*]$01	;Fill the rest of the page with NOP
